   --     - .
   --
   --  : .. (05-06.11.2010)
   --
   --       -
   --    -  
   --    [,,,1999]
   -----------------------------------------------------
module TreeRB
   (RBTree (..), rb_Ins, rb_Ins1, rb_Del, rb_Del1, chng_Clr,
    root, left, right, addTree, ud, delete, srch,
    search, subst, srch_G, srch_D, srch_B, srch_Nl, srch_Nr,
    srch_U, rot_Right, rot_Left, rotInTree, drawTree, outTree)
where

data RBTree = NIL (Char) | Node (Integer,Char) (RBTree) (RBTree)
   deriving Eq
-------------------------------------------------------------------
   -- rb_Ins -   -   tree,
   --               s
--------------------------------------------------
rb_Ins:: RBTree -> Integer -> RBTree
rb_Ins tree s = subst func (root func) (fst (root func),'B')
                   where func = rb_Ins1 (addTree s 'R' tree) s
-----------------------------------------------------------------
   -- rb_Ins1 -      tree  
   --           NIL-,        s
   --                 -
   --            
-------------------------------------
rb_Ins1:: RBTree -> Integer -> RBTree
rb_Ins1 tree s | s == fst (root tree) ||
                 snd (root (search (fst (srch_D s tree)) 
                                   tree)) == 'B' = tree 
               | (fst (srch_D s tree) < fst (srch_G s tree) ||
                  fst (srch_D s tree) > fst (srch_G s tree)) &&
                 (pSrch_U s tree) &&
                 snd (root (search (fst (srch_U s tree)) 
                                   tree)) == 'R'
                 = rb_Ins1 
                      (chng_Clr
                         (chng_Clr
                            (chng_Clr tree 
                                      (fst (srch_D s tree)) 'B') 
                            (fst (srch_G s tree)) 'R')
                         (fst (srch_U s tree)) 'B') 
                      (fst (srch_G s tree))
               | (fst (srch_D s tree) < fst (srch_G s tree) &&
                  s > fst (srch_D s tree)) ||
                 (fst (srch_D s tree) > fst (srch_G s tree) &&
                  s < fst (srch_D s tree))
                 = rb_Ins1 (rotInTree s tree) 
                           (fst (srch_D s tree))
               | True = 
                    rb_Ins1 
                       (rotInTree (fst (srch_D s tree))
                                  (chng_Clr 
                                     (chng_Clr tree  
                                               (fst (srch_D s tree))
                                               'B')
                                     (fst (srch_G s tree)) 'R')) s
-------------------------------------------------------------------
   -- rb_Del -   -   Tree,
   --               S
--------------------------------------------------
rb_Del:: RBTree -> Integer -> RBTree
rb_Del tree s | tree == (NIL ('B')) || not (srch s tree) = tree
              | snd (root (search s tree)) == 'R' &&
                (left (search s tree) == (NIL ('B')) ||
                 right (search s tree) == (NIL ('B'))) 
                = delete s tree
              | right (search s tree) == (NIL ('B')) &&
                left (search s tree) == (NIL ('B'))
                = delete s (rb_Del1 tree s)
              | True = delete s
                          (rb_Del1 tree predicat)
                   where predicat | right (search s tree) == 
                                                        (NIL ('B'))
                                    = fst (root 
                                            (left (search s tree)))
                                  | True = fst (ud 
                                           (right (search s tree)))
-------------------------------------------------------------------
   -- rb_Del1 -    -
   --               x
--------------------------------------------
rb_Del1:: RBTree -> Integer -> RBTree
rb_Del1 tree x | x == fst (root tree) ||
                 snd (root (search x tree)) == 'R' 
                 = subst tree (root (search x tree)) (x,'B')
               | not (pSrch_B x tree) = tree
               | (x < fst (srch_D x tree)  ||
                  x > fst (srch_D x tree)) &&
                 snd (root (search (fst (srch_B x tree)) tree)) 
                                 == 'R' 
                 = rb_Del1 
                      (rotInTree (fst (srch_B x tree))
                                 (chng_Clr 
                                    (chng_Clr tree 
                                         (fst (srch_D x tree)) 'R') 
                                    (fst (srch_B x tree)) 'B')) x
               | (x < fst (srch_D x tree) || 
                  x > fst (srch_D x tree)) &&
                 snd (root (search (fst (srch_B x tree)) 
                                   tree)) == 'B' &&
                 ((not (pSrch_Nl x tree) && 
                   not (pSrch_Nr x tree)) ||
                  (snd (root (search (fst (srch_Nl x tree)) 
                                     tree)) == 'B'&&
                   snd (root (search (fst (srch_Nr x tree)) 
                                     tree)) == 'B'))
                 = (rb_Del1 
                      (chng_Clr tree (fst (srch_B x tree)) 'R')
                      (fst (srch_D x tree)))
               | x < fst (srch_D x tree) &&
                 snd (root (search (fst (srch_Nr x tree)) 
                                   tree)) == 'B' 
                 = rb_Del1 
                      (rotInTree (fst (srch_Nl x tree))
                                 (chng_Clr 
                                    (chng_Clr tree 
                                         (fst (srch_B x tree)) 'R')
                                    (fst (srch_Nl x tree)) 'B')) x
               | x < fst (srch_D x tree) =
                 rotInTree (fst (srch_B x tree)) 
                    (chng_Clr 
                       (chng_Clr 
                          (chng_Clr tree 
                                    (fst (srch_D x tree)) 'B')
                          (fst (srch_B x tree)) 
                          (snd (root (search (fst (srch_D x tree))
                                             tree))))
                       (fst (srch_Nr x tree)) 'B')         
----------------------------------------------------
   -- ""    
----------------------------------------------------
               | x > fst (srch_D x tree) &&
                 snd (root (search (fst (srch_Nl x tree)) 
                                   tree)) == 'B'
                 = rb_Del1 
                     (rotInTree (fst (srch_Nr x tree)) 
                                (chng_Clr 
                                   (chng_Clr tree 
                                         (fst (srch_B x tree)) 'R')
                                   (fst (srch_Nr x tree)) 'B')) x
               | True = 
                    rotInTree (fst (srch_B x tree)) 
                              (chng_Clr
                                 (chng_Clr 
                                    (chng_Clr tree 
                                         (fst (srch_D x tree)) 'B')  
                                    (fst (srch_B x tree)) 
                                    (snd (root (search 
                                              (fst (srch_D x tree))
                                                           tree))))
                                 (fst (srch_Nl x tree)) 'B')         
-----------------------------------------------------------------
   -- chng_Clr -       
   --            tree  NIL-     
   --            
----------------------------------------------
chng_Clr:: RBTree -> Integer -> Char -> RBTree
chng_Clr tree v clr_V 
         | tree == (NIL ('B')) ||
           srch v tree == False = tree
         | True =  subst tree (root (search v tree))
                              (v,clr_V)
-----------------------------------------------------------
   --       
   -- Tree  NIL-
-------------------------------
root:: RBTree -> (Integer,Char)
root (NIL ('B'))  = error "  !"
root (Node a l r) = a
----------------------------------------------------------------
   --       
   -- Tree  NIL-
-----------------------
left:: RBTree -> RBTree
left (NIL ('B'))  = (NIL ('B'))
left (Node a l r) = l
-----------------------------------------------------------------
   --       
   -- Tree  NIL-
------------------------
right:: RBTree -> RBTree
right (NIL ('B'))  = (NIL ('B'))
right (Node a l r) = r
---------------------------------------------------------
   --      S   Color
   --     Tree  NIL-
------------------------------------------------
addTree:: Integer -> Char -> RBTree -> RBTree
addTree s color tree | tree == (NIL ('B')) = (Node (s,color)
                                                   (NIL ('B'))
                                                   (NIL ('B')))
                     | s == (fst (root tree)) = tree
                     | s < (fst (root tree)) =
                                (Node (root tree)
                                      (addTree s color (left tree))
                                      (right tree))
                     | True = (Node (root tree)
                                    (left tree)
                                    (addTree s color (right tree)))
-------------------------------------------------------------------
   --      S    
   -- Tree  NIL-.
   --     ,   -
   --     (     )
   --   .
   --  delete  ud   
   --  . [1985],    -
   --  Pascal,   
--------------------------------------------
delete:: Integer -> RBTree -> RBTree
delete s tree | tree == (NIL ('B')) = (NIL ('B'))
              | s < (fst (root tree)) = 
                         (Node (root tree) (delete s (left tree))
                                           (right tree))
              | s > (fst (root tree)) =
                         (Node (root tree) (left tree)
                                           (delete s (right tree)))
              | (right tree) == (NIL ('B')) = left tree
              | (left tree) == (NIL ('B')) = right tree
              | True = (Node (ud (right tree))
                                 (left tree)
                                 (delete 
                                     (fst (ud (right tree)))
                                     (right tree)))
---------------------------------------------------
   --     delete.
   --       
   --   Tree  NIL- 
-------------------------------------
ud:: RBTree -> (Integer,Char) 
ud tree | (left tree) == (NIL ('B')) = root tree
        | True = ud (left tree)
-------------------------------------------------------
   -- , ,    s 
   --    tree  NIL-
----------------------------------------------
srch:: Integer -> RBTree -> Bool
srch s tree | tree==(NIL ('B'))  = False
            | s==fst (root tree) = True
            | True               = srch s (left tree) 
                                   || srch s (right tree)
------------------------------------------------------------
   -- ,      tree 
   -- NIL-    s:    
   --    tree,     -
   --  s  ;    - (NIL ('B'))
-------------------------------------------------------------
search:: Integer -> RBTree -> RBTree
search s tree | tree == (NIL ('B')) = (NIL ('B'))
              | s == (fst (root tree)) = tree
              | s < (fst (root tree)) = search s (left tree)
              | True = search s (right tree)
-----------------------------------------------------------------
   --  ,     
   -- tree    a   b
------------------------------------------------------------
subst:: RBTree -> (Integer,Char) -> (Integer,Char) -> RBTree
subst tree a b | tree == (NIL ('B')) = (NIL ('B'))
               | root tree == a = (Node b (subst (left tree) a b)
                                          (subst (right tree) a b))
               | True = (Node (root tree) (subst (left tree) a b) 
                                          (subst (right tree) a b))
--------------------------------------------------------------------
   -- pSrch_G - , ,    ""  
   --              s    tree 
   --            NIL-
-----------------------------------
pSrch_G:: Integer -> RBTree -> Bool
pSrch_G s tree | not (pSrch_D s tree) = False 
               | True = pSrch_D (fst (srch_D s tree)) tree
---------------------------------------------------------------
   -- ,   ""   
   -- s    tree  NIL-
-------------------------------------------------
srch_G:: Integer -> RBTree -> (Integer,Char)
srch_G s tree | tree == (NIL ('B')) ||
                not (srch s tree) =
                              error " ''  !"
              | left (left tree) /= (NIL ('B'))   && 
                s == fst (root (left (left tree)))  ||
                right (left tree) /= (NIL ('B'))  &&
                s == fst (root (right (left tree))) ||
                left (right tree) /= (NIL ('B'))  &&
                s == fst (root (left (right tree))) ||
                right (right tree) /= (NIL ('B')) &&
                s == fst (root (right (right tree))) = root tree
              | srch s (left tree) = srch_G s (left tree)
              | True = srch_G s (right tree)
-------------------------------------------------------------------
   -- pSrch_D - , ,      ""
   --              s    tree 
   --            NIL-
-----------------------------------
pSrch_D:: Integer -> RBTree -> Bool
pSrch_D s tree | tree == (NIL ('B')) = False
               | True = not (s == fst (root tree) || 
                             not (srch s tree))
------------------------------------------------------------------
   -- srch_D - ,   ""   -
   --           s    tree  NIL-
---------------------------------------------------------------
srch_D:: Integer -> RBTree -> (Integer,Char)
srch_D s tree | tree == (NIL ('B'))  ||
                s == fst (root tree) ||
                not (srch s tree) =
                                 error " ''  !"
              | (left tree) /= (NIL ('B')) &&
                s == fst (root (left tree)) ||
                (right tree) /= (NIL ('B')) &&
                s == fst (root (right tree)) = root tree 
              | s < fst (srch_G s tree) = 
                    root (left (search (fst (srch_G s tree)) tree))
              | True = root (right (search 
                                       (fst (srch_G s tree)) tree))
-------------------------------------------------------------------
   -- pSrch_B - , ,      ""
   --              s    tree 
   --            NIL-
-----------------------------------
pSrch_B:: Integer -> RBTree -> Bool
pSrch_B s tree | not (pSrch_D s tree) = False
               | True = not (left (search (fst (srch_D s tree)) 
                                          tree) == (NIL ('B')) ||
                             right (search (fst (srch_D s tree)) 
                                           tree) == (NIL ('B'))) 
------------------------------------------------------------------
   -- srch_B - ,   ""   -
   --           s    tree  NIL-
---------------------------------------------------------------
srch_B:: Integer -> RBTree -> (Integer,Char)
srch_B s tree | not (pSrch_B s tree) =
                                 error " ''  !"
              | s < fst (srch_D s tree) = 
                   root (right (search (fst (srch_D s tree)) tree))
              | True = root (left (search 
                                       (fst (srch_D s tree)) tree))
--------------------------------------------------------------------
   -- pSrch_Nl - , ,    "-
   --            " ()    s 
   --              tree  NIL-
------------------------------------------------
pSrch_Nl:: Integer -> RBTree -> Bool
pSrch_Nl s tree | not (pSrch_B s tree) = False
                | True = not (left (search (fst (srch_B s tree)) 
                                           tree) == (NIL ('B'))) 
------------------------------------------------------------------
   -- srch_Nl - ,   "" () 
   --             s    tree  
   --           NIL-
---------------------------------------------
srch_Nl:: Integer -> RBTree -> (Integer,Char)
srch_Nl s tree | not (pSrch_Nl s tree) =  
                    error " ' ()'  !"
               | True = root (left (search 
                                       (fst (srch_B s tree)) tree))
-------------------------------------------------------------------
   -- pSrch_Nr - , ,     "-
   --            " ()    s 
   --              tree  NIL-
------------------------------------------------
pSrch_Nr:: Integer -> RBTree -> Bool
pSrch_Nr s tree | not (pSrch_B s tree) = False
                | True = not (right (search (fst (srch_B s tree)) 
                                            tree) == (NIL ('B'))) 
-----------------------------------------------------------------
   -- srch_Nr - ,   "" ()
   --              s       
   --           tree  NIL-
---------------------------------------------
srch_Nr:: Integer -> RBTree -> (Integer,Char)
srch_Nr s tree | not (pSrch_Nr s tree) = 
                   error " ' ()'  !"
               | True = root (right (search 
                                       (fst (srch_B s tree)) tree))
-------------------------------------------------------------------
   -- pSrch_U - , ,    "" 
   --              s    
   --           tree  NIL-
-----------------------------------
pSrch_U:: Integer -> RBTree -> Bool
pSrch_U s tree | not (pSrch_G s tree) = False
               | True = not (left (search (fst (srch_G s tree)) 
                                          tree) == (NIL ('B')) ||
                             right (search (fst (srch_G s tree)) 
                                           tree) == (NIL ('B'))) 
------------------------------------------------------------------
   -- srch_U - ,   ""   -
   --           s    Tree  NIL-   
---------------------------------------------------------------
srch_U:: Integer -> RBTree -> (Integer,Char)
srch_U s tree | not (pSrch_U s tree) =
                                 error " ''  !"
              | s < fst (srch_G s tree) = 
                   root (right (search (fst (srch_G s tree)) tree))
              | True = root (left (search 
                                       (fst (srch_G s tree)) tree))
-------------------------------------------------------------------
   -- rot_Right - ,   " "
   --                 tree  NIL-
------------------------------------------------------------
rot_Right:: RBTree -> RBTree
rot_Right tree | tree == (NIL ('B')) || 
                 left tree == (NIL ('B')) = tree
               | True = (Node (root (left tree))
                              (left (left tree))
                              (Node (root tree)
                                    (right (left tree))
                                    (right tree)))
---------------------------------------------------------------
   -- rot_Left - ,   " "
   --                 tree  NIL-
------------------------------------------------------------
rot_Left:: RBTree -> RBTree
rot_Left tree | tree == (NIL ('B')) || 
                right tree == (NIL ('B')) = tree
              | True = (Node (root (right tree))
                             (Node (root tree)
                                   (left tree)
                                   (left (right tree)))
                             (right (right tree)))
----------------------------------------------------------------
   -- rotInTree - ,    
   --                tree  NIL-  -
   --                ,     
   --              ,   s   
----------------------------------------------------------------
rotInTree:: Integer -> RBTree -> RBTree
rotInTree s tree | tree == (NIL ('B')) = (NIL ('B'))
                 | fst (root tree) == s = tree
                 | (left tree) /= (NIL ('B')) && 
                   fst (root (left tree)) == s = rot_Right tree
                 | (right tree) /= (NIL ('B')) &&
                   fst (root (right tree)) == s = (rot_Left tree)
                 | True = (Node (root tree)
                                (rotInTree s (left tree))
                                (rotInTree s (right tree)))
--------------------------------------------------------------
   -- drawTree -     tree   
   --             ;
   --            L -  ,   
   --                0
-----------------------------------------------------
drawTree:: RBTree -> Int -> String
drawTree tree l | tree==NIL ('B') = ""
                | otherwise = (drawTree (right tree) (l+1)) ++
                              "\n" ++ (replicate (l*3) ' ') ++
                              show (fst (root tree)) ++
                              "(" ++
                              [snd (root tree)] ++
                              ")" ++
                              (drawTree (left tree) (l+1))
----------------------------------------------------------
   -- outTree -      tree 
   --             
---------------------------------
outTree:: RBTree -> IO()
outTree tree = putStr ((drawTree tree 0) ++ "\n")
----------------------------------------------------------------
   --   RBTree    
   --    , ..   RBTree 
   --    Show
   ----------------------------------
instance Show RBTree where
show (NIL ('B')) = "nil(B)"
show (Node a (NIL ('B')) (NIL ('B'))) =
                  "(" ++ show (fst a) ++ "(" ++ [snd a] ++ ")"  
                       ++ " nil(B)" ++ " nil(B)" ++ ")"
show (Node a l r) =
                  "(" ++ show (fst a) ++ "(" ++ [snd a] ++ ")"  
                       ++ " " ++ show l ++ " " ++  show r ++ ")"
